// Flip-Pal Toolbox Common JavaScript functions
// 2013 Jan 16 - Jim Moy, jim.moy@couragent.net

function baseName(str) {
	result = str.replace( /.*\//, "" );
	return result;
}

function commandLine( comps, callback ) {
	if( typeof app != 'undefined' ) {
		// Difference in callback conventions from browser control
		if( navigator.platform.indexOf( "Mac" ) != -1 ) {
			app.commandLine( comps, callback ); // pass by name from Safari
		} else {
			// Chromium, under Windows
			// Name is key for lookup to this anonymous function in Chrome
			app.setMessageCallback( callback, function( name, args ) {
				eval( name )( args[0] );
			});
			// Normally could just call app.sendMessage(), but in CEF I am
			// getting Debug assertions if this is called from the callback of
			// another message that is pending cleanup. Usually the assertions
			// are caused by refcount problem but I'm not sure what the problem
			// is in this case. In any event, it doesn't hurt to spawn all
			// commands this way.
			window.setTimeout( function() {
				app.sendMessage( 'flipcmd', [callback].concat( comps ));
			}, 5 );
		}
	}
}

function is_mac() {
	return navigator.platform.indexOf( "Mac" ) != -1;
}

function is_windows() {
	return ! is_mac();
}

