import traceback

from base64 import b64encode, b64decode
from os import remove
from os.path import *

import simplejson as json

class PhotoloomCommand:

	def __init__( self, inp, out, path ):
		self.save_name = "photoloom_settings.txt"
		self.input = inp
		self.output = out
		self.rsrc_path = path
		self.username = None
		self.password = None

	def error( self, msg ):
		return { 'status' : "error", 'message' : msg }

	def save_path( self ):
		return join( self.rsrc_path, self.save_name )

	def run_command( self, args ):
		try:
			if args[0] == 'login':
				if len( args ) != 3 and len( args ) != 1:
					return self.error( "need login, password, or nothing" )
				email = None
				passwd = None
				if len( args ) == 3:
					email = args[1]
					passwd = args[2]
				result = self.login( email, passwd )
			elif args[0] == 'save_login':
				result = self.save_login()
			elif args[0] == 'logout':
				result = self.logout()
			elif args[0] == 'upload':
				if len( args ) != 2:
					return self.error( "need path to file" )
				result = self.upload( args[1] )
			else:
				if len( args ) == 0: args = ["<unknown>"]
				return self.error( "unrecognized picasa command: %s" % args[0] )
		except:
			result = { 'message' : "exception in command '%s'" % args[0],
						'status' : "error", 'traceback' : traceback.format_exc() }
		return result

	def login( self, email, password ):
		try:
			if email == None and password == None:
				# login with no params, try saved value
				try:
					f = open( self.save_path(), "r" )
					data = json.load( f )
					email = b64decode( data['a'] )
					password = b64decode( data['b'] )
				finally:
					if f: f.close()
			self.username = email
			self.password = password
			# self.client = gdata.photos.service.PhotosService()
			# self.client.email = email
			# self.client.password = password
			# self.client.source = "FlipPal Toolbox"
			# self.client.ProgrammaticLogin()
			# result = { 'status' : "ok" }
			result = { 'status' : "error", 'message' : "login failed" }
		except:
			result = { 'status' : "error", 'message' : "login failed" }
		return result

	def save_login( self ):
		if not self.username:
			return { 'status' : "error", 'message' : "not logged in" }
		email = self.username
		passwd = self.password
		try:
			data = {
				'a' : b64encode( self.client.email ),
				'b' : b64encode( self.client.password )
			};
			f = open( self.save_path(), "w" )
			json.dump( data, f )
			result = { 'status' : "ok" }
		except:
			result = { 'status' : "error", 
					'message' : "could not open save file" }
		finally:
			if f: f.close()
		return result

	def logout( self ):
		self.username = None
		self.album = None
		try:
			result = { 'status' : "ok" }
			path = self.save_path()
			if isfile( path ):
				remove( path )
		finally:
			pass
		return result


	def upload( self, path ):
		if not self.username:
			return { 'status' : "error", 'message' : "not logged in" }
		if isfile( path ):
			photo_name = basename( path )
			# photo = self.client.InsertPhotoSimple( album_url, photo_name, photo_name, path )
			result = { 'status' : "ok" }
		else:
			result = { 'status' : "error", 'message' : "Could not find file: %s" % path }
		return result
