import os
from os.path import *
from threading import Thread
from urllib import urlopen
from SocketServer import ThreadingMixIn
from BaseHTTPServer import HTTPServer, BaseHTTPRequestHandler

server_port = 4082
server_path = ""
running = False

class Handler(BaseHTTPRequestHandler):
    def do_GET(self):
		try:
			f = None
			fpath = join( server_path, self.path[1:] )
			if isfile( fpath ):
				f = open( fpath, "rb" )
				self.send_response(200)
				t = "text/html"
				if fpath.endswith( ".css" ):
					t = "text/css"
				self.send_header("Content-type", t )
				self.end_headers()
				self.wfile.write( f.read() )
		except:
			self.send_response( 400, "Whoops. (%s)" % self.path )
		finally:
			if f: f.close()

class ThreadingHTTPServer(ThreadingMixIn, HTTPServer):
	pass

def serve_on_port(port):
	global running
	server = ThreadingHTTPServer(("localhost",port), Handler)
	running = True
	while running:
		server.handle_request()

def start( path ):
	global server_port
	global server_path
	server_path = join( path, "html" )
	os.chdir( server_path )
	Thread(target=serve_on_port, args=[server_port]).start()

def stop():
	global server_port
	global running
	running = False
	# Ping the server so handle_request() returns and the loop exits
	urlopen( "http://localhost:%d" % server_port )
