// Flip-Pal Toolbox Photoloom Support
// 2013 Jan 09 - Jim Moy, jim.moy@couragent.net

function photoloomLogin() {
	$('#login-dialog form input').blur();
	if( typeof app != 'undefined' ) {
		var emailArg = '"' + $('#login-email').val() + '"';
		var passwordArg = '"' + $('#login-password').val() + '"';
		app.commandLine(['photoloom', 'login', emailArg, passwordArg], 'photoloomLoginCallback' );
	}
}

function photoloomLoginCallback( arg ) {
	var obj = $.parseJSON( arg )
	if( obj && obj.status == "ok" ) {
		$('#login-failed').hide('fast');
		// Put away the "logging in dialog"
		$('#login-dialog').modal( 'hide' );
		app.commandLine( ['photoloom', 'save_login'], '' );
		photoloomShowThumbnails();
	} else {
		$('#login-failed').show('fast');
		$('#login-email').focus();
	}
}

function photoloomShowThumbnails() {
	$('#shareui').hide();
	$('#imageui').show();
	// Put up the thumbnails
	window.flipUploadSite = 'photoloom';
	app.sendMessage( 'flipstitchthumbs' );
}

function photoloomLoginDialog() {
	$('#login-dialog').bind( 'shown', function() {
		$('#stitch-dialog').unbind( 'shown' ); // otherwise fires twice
		$('#login-dialog form input').keydown( function( event ){
			$('#login-failed').hide('fast');
			if( event.keyCode == 13 ) {
				photoloomLogin();
				event.preventDefault();
				return false;
			}
		});
		$('#login-email').focus();
	});
	$("#login-submit").click(function(event){
		photoloomLogin();
		return false;
	});
	$('#login-logo').attr( 'src', "images/photoloom.png" );
	$('#login-account-link').click( function( event ) {
		commandLine([ 'sysopen', 'http://couragent.net/toolbox/redirect/photoloom/create/'], '' );
		return false;
	});
	// <localize>
	$('#login-label').html( "Photoloom Image Upload" );
	$('#login-prompt').html( "Login to Photoloom:" );
	$('#login-account-link').html( "Get a Photoloom account" );
	// </localize>
	$('#login-failed').hide();
	$('#login-dialog').modal({ backdrop: 'static', keyboard: false, show: true });
}

function photoloomCheckLoginCallback( arg ) {
	var obj = $.parseJSON( arg )
	if( obj && obj.status == "ok" ) {
		photoloomShowThumbnails();
	} else {
		photoloomLoginDialog();
	}
}

function photoloomLogoutCallback( arg ) {
	var obj = $.parseJSON( arg )
}

function photoloomLogout() {
	if( typeof app != 'undefined' ) {
		app.commandLine( ['photoloom', 'logout'], 'photoloomLogoutCallback' );
	}
	$('#imageui').hide();
	$('#shareui').show();
}

function photoloomUploadCallback( arg ) {
	var obj = $.parseJSON( arg )
	if( obj && obj.status == "ok" ) {
		window.flipPhotoloomIndex++;
		var pct = 100 * window.flipPhotoloomIndex / window.flipPhotoloomCount;
		$('#progress-bar').css( 'width',  Math.round(pct) + "%" );
		if( window.flipPhotoloomIndex < window.flipPhotoloomCount ) {
			// Upload next file
			var path = window.flipPhotoloomList[window.flipPhotoloomIndex];
			app.commandLine(['photoloom', 'upload', path], 'photoloomUploadCallback' );
		} else {
			$('#upload-dialog').modal( 'hide' );
		}
	} else {
		$('#upload-dialog').modal( 'hide' );
		// Show error message
		$('#info-dialog').bind( 'shown', function() {
			$('#info_prompt').html( "Could not upload the image." );
			$('#stitch-dialog').unbind( 'shown' ); // otherwise fires twice
		});
		// Invokes 'shown' event, above
		$('#info-dialog').modal({ backdrop: 'static', keyboard: false, show: true });
	}
}

function photoloomUpload( list ) {
	window.flipPhotoloomList = list;
	window.flipPhotoloomIndex = 0;
	window.flipPhotoloomCount = list.length;
	app.commandLine(['photoloom', 'upload', list[0]], 'photoloomUploadCallback' );
}

